Subject: automatic parallelization - summery

From: Zilberman Silviu <[email-masked]>
Date: Mon, 03 Dec 2001 06:49:34 +0000

Hi everyone,

It seems that my question is of interest to many people, though I got
only two serious replys. The bottom line from those answers is not to
expect too much. It might work for a shared memory SMP machine, but it
is not particulary good for distributed memory machines. Attached is my
original question and the replys.

Silviu.

-------- Original Message --------
Hi everyone,

Does anyone has experience with using auotmatic parallelization tools,
for old Fortran and C codes?
We are buying a PC cluster, and I look for a quick and dirty way of
getting parallel codes out of seriel one.

Thanks,
Silviu Zilberman.

-- 
Subject: 
           Re: CCL:automatic parallelization
      Date: 
           29 Nov 2001 17:36:42 +0100
      From: 
           Konrad Hinsen <[email-masked]>
        To: 
           Zilberman Silviu <[email-masked]>
 References: 
           1

Zilberman Silviu <[email-masked]> writes:

> Does anyone has experience with using auotmatic parallelization tools,
> for old Fortran and C codes?
> We are buying a PC cluster, and I look for a quick and dirty way of
> getting parallel codes out of seriel one.

Don't expect much from them. Automatic parallelization for SMP
machines works well for some codes, but certainly not for all. And I
haven't even seen a production compiler that pretends to do automatic
parallelization for distributed memory machines such as a PC cluster.
If you get biprocessor nodes, you might have some success. Just try
the new Intel compilers for Linux with the free evaluation licence!
-- 

Subject: 
           Re: CCL:automatic parallelization
      Date: 
           Thu, 29 Nov 2001 17:34:39 +0000
      From: 
           Maurice Cafiero <[email-masked]>
        To: 
           Zilberman Silviu <[email-masked]>
        CC: 
           ccl <[email-masked]>
 References: 
           1

hello: 
    I have used the automatic parallelization tools that come with SGI
Fortan, and they 
are pretty terrible. They created a 2/3% speedup and were about 5%
parallel. 
    I suggest 2 things: 

    1) Use parallel numerical libraries. These are pre-existing and can
probably be downloaded 
          from netlib. 

    2) Learning basic MPI is not difficult at all for an experienced
FORTRAN programmer. 
          I learned it in about 3 weeks and my code is 80/90% parallel.
I get excellent speedup 
          (approximately linear with # procs). 

What type of program are you trying to parallelize? 

-- 
Mauricio Cafiero
Doctoral Candidate : Theoretical
                     and Computational
                     Quantum Chemistry
Department of Chemistry
University of Arizona